HDU 3032-Nim or not Nim?(sg函数打表)

来源:互联网 发布:省市区三级联动数据库 编辑:程序博客网 时间:2024/05/29 18:35

Nim or not Nim?

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 1099    Accepted Submission(s): 547


Problem Description
Nim is a two-player mathematic game of strategy in which players take turns removing objects from distinct heaps. On each turn, a player must remove at least one object, and may remove any number of objects provided they all come from the same heap.

Nim is usually played as a misere game, in which the player to take the last object loses. Nim can also be played as a normal play game, which means that the person who makes the last move (i.e., who takes the last object) wins. This is called normal play because most games follow this convention, even though Nim usually does not.

Alice and Bob is tired of playing Nim under the standard rule, so they make a difference by also allowing the player to separate one of the heaps into two smaller ones. That is, each turn the player may either remove any number of objects from a heap or separate a heap into two smaller ones, and the one who takes the last object wins.
 

Input
Input contains multiple test cases. The first line is an integer 1 ≤ T ≤ 100, the number of test cases. Each case begins with an integer N, indicating the number of the heaps, the next line contains N integers s[0], s[1], ...., s[N-1], representing heaps with s[0], s[1], ..., s[N-1] objects respectively.(1 ≤ N ≤ 10^6, 1 ≤ S[i] ≤ 2^31 - 1)
 

Output
For each test case, output a line which contains either "Alice" or "Bob", which is the winner of this game. Alice will play first. You may asume they never make mistakes.
 

Sample Input
232 2 323 3
 

Sample Output
AliceBob
 
题意:有T组数据,n堆物品,每堆有X个物品,Alice先拿,最后一个拿的取胜,问谁赢。
思路:典型的sg的打表题,打完表后发现规律:
sg[4k]=4k-1
sg[4k+1]=4k+1;
sg[4k+2]=4k+2;
sg[4k+3]=4k+4;

#include <stdio.h>#include <math.h>#include <string.h>#include <stdlib.h>#include <iostream>#include <sstream>#include <algorithm>#include <set>#include <queue>#include <stack>#include <map>using namespace std;typedef long long LL;const int inf=0x3f3f3f3f;const double pi= acos(-1.0);int sg[100010];/*int get_sg(int x){    int ans,i;    int mex[100010];    memset(mex,0,sizeof(mex));    for(i=x-1;i>=0;i--){//当选择拿出石子时的sg后继标记        mex[sg[i]]=1;    }    for(i=1;i<=x/2;i++){//当选择分成两堆时的sg后继标记        ans=0;        ans^=sg[i];        ans^=sg[x-i];        mex[ans]=1;    }    for(i=0;;i++){//最小的非sg后继数        if(!mex[i]){            sg[x]=i;            return sg[x];        }    }}int main(){    int i;    sg[0]=0;    for(i=1;i<100;i++){        get_sg(i);        printf("sg[%d]->%d\n",i,sg[i]);    }    return 0;}*/int main(){    int T,n,x,i;    int sum;    scanf("%d",&T);    while(T--){        scanf("%d",&n);        sum=0;        for(i=0;i<n;i++){            scanf("%d",&x);            if(x%4==0)                sum^=x-1;            else if(x%4==1||x%4==2)                sum^=x;            else                sum^=x+1;        }        if(sum)            printf("Alice\n");        else            printf("Bob\n");    }    return 0;}



1 0
原创粉丝点击